/******************************************************************************
 * This file is part of a software distribution, which is furnished under the *
 * terms of a license.  Use of this software  by any means is subject to this *
 * license  and  signifies  the  acceptance of  the  licensing  terms  stated *
 * therein. Please see  the file LICENSE in the  top-level directory  of this *
 * software  distribution  for detailed copyright  disclaimers  and licensing *
 * terms.                                                                     *
 ******************************************************************************
 * Copryight (c) by Andreas S. Wetzel - All rights reserved.                  *
 ******************************************************************************/

/* $Id: vchatctl.h,v 1.1 2001/04/09 18:30:43 mickey Exp $ */

#ifndef __VCHATCTL_H__
#define	__VCHATCTL_H__

/*
 * Suck in config.h
 */

#include <config.h>

/*
 * Include commonly used header files
 */

#include <stdio.h>

#if HAVE_STRING_H
#  include <string.h>
#endif

#if HAVE_STRINGS_H
#  include <strings.h>
#endif

#if HAVE_CTYPE_H
#  include <ctype.h>
#endif

#include <stdlib.h>
#include <stdarg.h>
#include <sys/types.h>
#include <limits.h>
#include <errno.h>

#ifndef INADDR_NONE
#  define INADDR_NONE	0xffffffff
#endif

#if HAVE_UNISTD_H
#  include <unistd.h>
#endif

#if TIME_WITH_SYS_TIME
#  include <sys/time.h>
#  include <time.h>
#else
#  if HAVE_SYS_TIME_H
#    include <sys/time.h>
#  else
#    include <time.h>
#  endif
#endif

/*
 * Include common VChat headers
 */


/*
 * Set up some handy macros
 */

#if HAVE_BCOPY
#  define	BCOPY(a,b,c)		bcopy(a,b,c)
#elif HAVE_MEMCPY
#  define	BCOPY(a,b,c)		memcpy(b,a,c)
#else
#  error "Neither bcopy nor memcpy are available"
#endif

#if HAVE_BZERO
#  define	BZERO(a,b)		bzero(a,b)
#elif HAVE_MEMSET
#  define	BZERO(a,b)		memset(a,0,b)
#else
#  error "Neither bzero nor memset are available"
#endif

#if HAVE_BCMP
#  define	BCMP(a,b,c)		bcmp(a,b,c)
#elif HAVE_MEMCMP
#  define	BCMP(a,b,c)		memcmp(a,b,c)
#else
#  error "Neither bcmp nor memcmp are available"
#endif

#define GETPEERNAME(a,b,c)	getpeername(a, (struct sockaddr *)b, (int *)c)
#define GETSOCKNAME(a,b,c)	getsockname(a, (struct sockaddr *)b, (int *)c)
#define RECVFROM(a,b,c,d,e,f)	recvfrom(a, (void *)b, (size_t)c, d, (struct sockaddr *)e, (int *)f)
#define SENDTO(a,b,c,d,e,f)	sendto(a, (void *)b, (size_t)c, d, (struct sockaddr *)e, f)

#endif /* __VCHATCTL_H__ */
