/* $Id: main.c,v 1.1 2001/04/09 18:30:42 mickey Exp $ */

#include <vchatctl.h>
#include <proto.h>

#include <sys/socket.h>
#include <sys/un.h>

/*** Globals ***/

char	*prog_name;
char	*connectsockname = "/tmp/vctl";
int	ctlsock;
struct	sockaddr_un sa;
struct	sockaddr_un connsa;

/*** Code ***/

int main(int argc, char *argv[])
{
	/*** Get program name ***/

	if((prog_name = (char *)strrchr(argv[0], '/')) != NULL)
		++prog_name;
	else
		prog_name = argv[0];

	--argc;
	++argv;

	/*
	 * Determine operating mode
	 */

	if(!strcmp(prog_name, "vchatctl.cgi"))
	{
		return(op_html());
	}
	else if(!strcmp(prog_name, "webchat_list.cgi"))
	{
		return(op_webchatlist());
	}
	else if(!strcmp(prog_name, "vchatctl"))
	{
		/**/
	}
	else
	{
		fprintf(stderr, "%s: wrong program name -- program must be either called 'vchatctl' or 'vchatctl.cgi'\n", prog_name);
		return(-1);
	}

	/*
	 * Initialize control socket
	 */

	if(init_ctlsock() == -1)
	{
		fprintf(stderr, "%s: failed to initialize control socket.\n", prog_name);
		return(-1);
	}

	/*
	 * If any commandline arguments are given
	 * process them. Otherwise enter command mode.
	 */

	if(argc)
	{
		while(argc)
		{
			if(!strcmp(*argv, "-connect"))
			{
				--argc;
				++argv;

				if(argc)
				{
					connectsockname = *argv;
				}
				else
				{
					usage("Option -connect requires an argument");
					break;
				}
			}
			else if(!strcmp(*argv, "-kill"))
			{
				--argc;
				++argv;

				if(argc)
				{
					kill(*argv, 0);
				}
				else
				{
					usage("Option -kill requires an argument");
					break;
				}
			}
			else if(!strcmp(*argv, "-killsilent"))
			{
				--argc;
				++argv;

				if(argc)
				{
					kill(*argv, 1);
				}
				else
				{
					usage("Option -killsilent requires an argument");
					break;
				}
			}
			else if(!strcmp(*argv, "-ulist"))
			{
				ulist();				
			}
			else if(!strcmp(*argv, "-wall"))
			{
				--argc;
				++argv;

				if(argc)
				{
					wall(*argv);
				}
				else
				{
					usage("Option -wall requires an argument");
					break;
				}
			}
			else if(!strcmp(*argv, "-shutdown"))
			{
				server_shutdown();
			}
			else if(!strcmp(*argv, "-suppress"))
			{
				suppress();
			}
			else
			{
				usage("Unrecognized option: %s", *argv);
				break;
			}

			--argc;
			++argv;
		}

		printf("\n");
		fflush(stdout);
	}
	else
	{
		op_text();
	}

	unlink(sa.sun_path);

	return(0);
}
