/* $Id: usage.c,v 1.1 2001/04/09 18:30:42 mickey Exp $ */

#include <vchatctl.h>
#include <proto.h>

#include "../vserver/include/vctlproto.h"

/*** Externals ***/

extern char	*prog_name;

/*** Code ***/

void usage(char *fmt, ...)
{
	va_list ap;

	va_start(ap, fmt);

	fprintf(stderr, "\n ==============================================================================\n");
	fprintf(stderr, "            vchatctl %s - %s\n", VERSION, REL_DATE);
	fprintf(stderr, "            (c) 1993, 1994, 1995, 1996, 1997, 1998, 1999, 2000, 2001\n");
	fprintf(stderr, "            by Andreas S. Wetzel - All rights reserved.\n");
	fprintf(stderr, " ==============================================================================\n\n");

	vfprintf(stderr, fmt, ap);
	fprintf(stderr, "\n\n");

	fprintf(stderr, "USAGE:   %s [-kill <nick> | -suppress | -ulist | -wall <msg> | -shutdown]\n\n",
		prog_name);
	fprintf(stderr, "OPTIONS: -kill <nick>       Kill the user with the specified nickname\n");
	fprintf(stderr, "         -suppress          Toggle anonymous conference server mode\n");
	fprintf(stderr, "         -ulist             List all currently active users\n");
	fprintf(stderr, "         -wall <msg>        Send <msg> to all currently active users\n");
	fprintf(stderr, "         -shutdown          Request conference server shutdown\n\n");

	fprintf(stderr, "When called without arguments, %s will enter interactive mode.\n",
		prog_name);

	va_end(ap);
}
