/* $Id: vctl_webchatlist.c,v 1.1 2001/04/09 18:30:43 mickey Exp $ */

#include <vchatctl.h>
#include <proto.h>
#include "../vserver/include/vctlproto.h"

#include <sys/socket.h>
#include <sys/un.h>

/*** Externals ***/

extern	char			*prog_name;
extern	char			*ctlsockname;
extern	int			ctlsock;
extern	struct	sockaddr_un	sa;
extern	struct	sockaddr_un	connsa;

/*** Defines ***/

#define ADDRESS "/tmp/vcontrol.%d"

#ifndef AF_LOCAL
  #define AF_LOCAL AF_UNIX
#endif

#ifndef PF_LOCAL
  #define PF_LOCAL PF_UNIX
#endif

#ifndef SUN_LEN
  #define SUN_LEN(x) (strlen((x)->sun_path) + sizeof((x)->sun_family))
#endif

/*** Code ***/

int op_webchatlist(void)
{
	VCTL			vctl;
	struct	sockaddr_un	fsa;

	int			fsalen	= sizeof(fsa);

	/*
	 * Output mime type header
	 */

	printf("Content-type: text/plain\n\n");
	fflush(stdout);

	/*
	 * Initialize control socket
	 */

	if(init_ctlsock() == -1)
		return(-1);

	/*
	 * Send request to server control socket
	 */

	vctl.type = VCTL_ULIST2;
	vctl.flags = 0;
	vctl.data[0] = '\0';
	vctl.len = VCTL_LEN(&vctl);

	if(SENDTO(ctlsock, &vctl, vctl.len, 0, &connsa, SUN_LEN(&connsa)) == -1)
		return(-1);

	BZERO(&vctl, sizeof(VCTL));

	while(RECVFROM(ctlsock, &vctl, sizeof(VCTL), 0, &fsa, &fsalen) != -1)
	{
		switch(vctl.type)
		{
			case VCTL_UINFO:	printf("%s\n", vctl.data);
						break;

			default:		break;
		}

		if(vctl.flags == VCTL_MSGCT)
			break;

		BZERO(&vctl, sizeof(VCTL));
	}

	/*
	 * Remove control socket and exit
	 */

	unlink(sa.sun_path);

	return(0);
}
