/* $Id: cmd_acl_delete.c,v 1.2 2002/06/23 23:16:04 mickey Exp $ */

#include <vserver.h>
#include <vproto/types.h>
#include <proto.h>
#include <extern.h>

/*
 * void cmd_acl_delete(CLDATA *ptr, u_char *dat);
 *
 * Delete a specific ACL rule.
 */

void cmd_acl_delete(CLDATA *ptr, u_char *dat, size_t len)
{
	/*
	 * Check if the client is permitted to use ACL commands
	 */

	if(!(ptr->accperm & AUTH_ACL))
	{
		snd_svmsg(ptr, "* You are not authorized to use ACL commands");
		return;
	}

	/*
	 * Check if the supplied argument has correct size
	 */

	if(len != sizeof(u_short))
	{
		snd_svmsg(ptr, "* Argument supplied for ACL_DELETE has invalid size (%d instead of %d)",
			len, sizeof(u_short));
		return;
	}
	else
	{
		u_short	*num	= (u_short *)dat;
		u_short rule;

		rule = ntohs(*num);

		if(rule > 65534)
		{
			snd_svmsg(ptr, "* The supplied rule number is out of range - use a value between 0 and 65534");
			return;
		}

		switch(acl_delete_rule(rule))
		{
			case -1:	snd_svmsg(ptr, "* Memory reallocation failure");
					break;
			case 0:		snd_svmsg(ptr, "* No rule matching 0x%04X found", rule);
					break;
			default:	snd_svmsg(ptr, "* delete 0x%04X", rule);
					break;
		}
	}
}
