/* $Id: cmd_acl_list.c,v 1.2 2002/06/23 23:16:04 mickey Exp $ */

#include <vserver.h>
#include <vproto/types.h>
#include <proto.h>
#include <extern.h>

/*
 * void cmd_acl_list(CLDATA *ptr);
 *
 * Process ACL commands
 */

void cmd_acl_list(CLDATA *ptr)
{
	/*
	 * Check if the client is permitted to use ACL commands
	 */

	if(!(ptr->accperm & AUTH_ACL))
	{
		snd_svmsg(ptr, "* You are not authorized to use ACL commands");
		return;
	}
	else
	{
		register int	i;
		ACLRULE		*acl;
		u_char		rulestr[256];

		snd_svmsg(ptr, "\n*%s%s                                %s ACL SETUP %s                                  %s",
			S_BG_BLU, S_FG_WHT, S_BG_RED, S_BG_BLU, S_OFF);

		for(i = 0; i < acl_numrules; i++)
		{
			acl = RULE(i);

			acl_print_rule(acl, rulestr);

			snd_svmsg(ptr, "* %s", rulestr);
		}

		snd_svmsg(ptr, "* 0xFFFF accept any");
	}
}
