/* $Id: cmd_broadcast.c,v 1.1 2001/04/09 18:30:43 mickey Exp $ */

#include <vserver.h>
#include <vproto/types.h>
#include <proto.h>
#include <extern.h>

/*
 * void cmd_broadcast(CLDATA *ptr, u_char *dat);
 *
 * Send a broadcast message to all users.
 */

void cmd_broadcast(CLDATA *ptr, u_char *dat)
{
	register int	i;
	register CLDATA	*cl;
	time_t		now;
	u_char		tbuf[80];

	/*
	 * Check if the client is permitted to send broadcasts
	 */

	if(!(ptr->accperm & AUTH_BROADCAST))
	{
		snd_svmsg(ptr, "* You are not authorized to send broadcast messages");
		return;
	}

	/*
	 * Check if a message was given
	 */

	if(dat == NULL)
	{
		snd_svmsg(ptr, "* No message - no broadcast");
		return;
	}

	while(*dat != '\0' && *dat == ' ')
		++dat;

	if(*dat == '\0')
	{
		snd_svmsg(ptr, "* No message - no broadcast");
		return;
	}

	/*
	 * Get current time
	 */

	time(&now);
	strftime(tbuf, 80, "%a %b %d %H:%M:%S %Z %Y", localtime(&now));

	/*
	 * Send message to all logged on users
	 */

	for(i = 0; i < clients; i++)
	{
		cl = cl_addr(i);

		snd_svmsg(cl, "* Broadcast message from %s%s%s at %s\n%s%s%s\n* EOT",
			S_FG_YEL, ptr->nick, S_OFF, tbuf,
			S_BOLD, dat, S_OFF);
	}

	if(clients == 1)
		snd_svmsg(ptr, "* 1 user notified");
	else
		snd_svmsg(ptr, "* %d users notified", clients);
}
