/* $Id: cmd_chanlist.c,v 1.1 2001/04/09 18:30:43 mickey Exp $ */

#include <vserver.h>
#include <vproto/types.h>
#include <proto.h>
#include <extern.h>

/*
 * void cmd_chanlist(CLDATA *ptr);
 *
 * List all currently active conference channels and their topics
 */

void cmd_chanlist(CLDATA *ptr)
{
	TABLE				cltab;
	register struct chantopic	*ct;
	register u_long			i;
	register int			n	= 0;

	table_init(&cltab, ptr);

	for(i = 0; i < vtop.entries; i++)
	{	
		ct = TOPADDR(i);

		if(!i)
		{
			table_printf(&cltab, "\n*%s%s     CHANNEL USER TOPIC                                           IDLE       %s",
				S_BG_BLU, S_FG_WHT, S_OFF);
		}

		if(ct->channel >= 0)
			table_printf(&cltab, "\n* %11d %4d %-47s %s",
				ct->channel, chatters(ct->channel), ct->topic, pftime(ct->stamp));
		else
			table_printf(&cltab, "\n*      ?????? %4d %-47s %s",
				chatters(ct->channel), ct->topic, pftime(ct->stamp));

		++n;
	}

	if(!n)
		snd_svmsg(ptr, "* No topic is assigned to any channel.");
	else
		table_flush(&cltab);
}
