/* $Id: cmd_chchan.c,v 1.1 2001/04/09 18:30:43 mickey Exp $ */

#include <vserver.h>
#include <vproto/types.h>
#include <proto.h>
#include <extern.h>

/*
 * void cmd_chchan(CLDATA *ptr, u_char *dat);
 *
 * Change the current conference channel
 */

void cmd_chchan(CLDATA *ptr, u_char *dat)
{
	signed long	newchan	= ntohl(*(signed long *)dat);

	if(newchan != ptr->channel)
	{
		register CLDATA	*pt;
		register int	i;
		char		*chantop = topic_ptr(newchan);

		for(i = 0; i < clients; i++)
		{
			pt = cl_addr(i);

			if(pt->fd == ptr->fd)
			{
				snd_svmsg(pt, "* You are now on channel %s%d%s",
				S_FG_BLU, newchan, S_OFF);

				if(chantop)
				{
					snd_svmsg(pt, "* Topic on this channel is '%s%s%s'", 
						S_BOLD, chantop, S_OFF);
				}
				else
				{
					store_topic(newchan, "-none-", CHFLG_REMOVABLE);
					touch_channel(newchan);
				}
			}
			else if(pt->channel == ptr->channel)
			{
				snd_svmsg(pt, "* %s%s%s left this channel",
				S_FG_YEL, ptr->nick, S_OFF);
			}
			else if(pt->channel == newchan)
			{
				snd_svmsg(pt, "* %s%s%s joined this channel",
				S_FG_YEL, ptr->nick, S_OFF);
			}
		}

		/*
		 * The channel topic is expired by
		 * the last user leaving the channel
		 */
		
		if(chatters(ptr->channel) == 1)
			remove_topic(ptr->channel, CHFLG_REMOVABLE);

		/*
		 * Send channel acknowledge
		 */

		snd2client(ptr, CHAN_ACK, dat, sizeof(signed long));

		/*
		 * Warp user to new channel
		 */

		ptr->channel = newchan;

		/*
		 * If no channeltopic was previously set for
		 * this channel, then request the client to
		 * submit a new topic for the channel.
		 */

		if(chantop == NULL)
			snd2client(ptr, SUBMIT_TOPIC, NULL, 0);
	}
	else
	{
		snd_svmsg(ptr, "* You are already on channel %d", newchan);
	}
}
