/* $Id: cmd_chtopic.c,v 1.1 2001/04/09 18:30:44 mickey Exp $ */

#include <vserver.h>
#include <vproto/types.h>
#include <proto.h>
#include <extern.h>

/*
 * void cmd_chtopic(CLDATA *ptr, u_char *dat);
 *
 * Change the topic of the current conference channel to the specified
 * string.
 */

void cmd_chtopic(CLDATA *ptr, u_char *dat)
{
	register int	i;
	register CLDATA	*cl;

	/*
	 * Store topic to topic table
	 */

	if(store_topic(ptr->channel, dat, CHFLG_REMOVABLE) == -1)
	{
		snd_svmsg(ptr, "* This channel has a fixed topic which must not be changed");
		return;
	}

	touch_channel(ptr->channel);

	/*
	 * Inform other user about the topic change
	 */

	for(i = 0; i < clients; i++)
	{
		cl = cl_addr(i);

		if(cl->channel == ptr->channel)
			snd_svmsg(cl, "* Topic changed to '%s%s%s' by %s%s%s",
				S_BOLD, dat, S_OFF, S_FG_YEL, ptr->nick, S_OFF);
	}

	vlog(VLOG_INFO, "Topic change CHANNEL: %d NEW-TOPIC: '%s' SET-BY: %s",
		ptr->channel, dat, ptr->nick);
}
