/* $Id: cmd_rtcmp.c,v 1.1 2001/04/09 18:30:44 mickey Exp $ */

#include <vserver.h>
#include <vproto/types.h>
#include <proto.h>
#include <extern.h>

#include <errno.h>

#if HAVE_SYS_UIO_H
  #include <sys/uio.h>
#endif

/*
 * void cmd_rtcmp(CLDATA *ptr, u_char *dat);
 *
 * Return RTCMP packet to client
 */

void cmd_rtcmp(CLDATA *ptr, u_char *dat)
{
#if HAVE_SYS_UIO_H
	RTCMP *rtcmp = (RTCMP *)dat;
	struct iovec iov[2];

	VMSG svmsg;

	if(ptr->flags & CFLAG_ERROR)
		return;

	/*
	 * Respond to RTCMP request.
	 */

	svmsg.cmd = htonl(RTCMP_ACK);
	svmsg.len = htonl(sizeof(RTCMP));

	iov[0].iov_base = (char *)&svmsg;
	iov[1].iov_base = (char *)rtcmp;
	iov[0].iov_len = sizeof(VMSG);
	iov[1].iov_len = sizeof(RTCMP);

	if(vio_writev(ptr->fd, (struct iovec *)&iov, 2, CONN_TIMEOUT) == -1)
#else
	u_char	sndbuf[sizeof(VMSG) + sizeof(RTCMP)];
	RTCMP	*rtcmp;
	VMSG	*svmsg;

	svmsg = (VMSG *)&sndbuf;
	rtcmp = (RTCMP *)&sndbuf[sizeof(VMSG)];

	if(ptr->flags & CFLAG_ERROR)
		return;
	
	/*
	 * Respond to RTCMP request.
	 */

	svmsg->cmd = htonl(RTCMP_ACK);
	svmsg->len = htonl(sizeof(RTCMP));
	BCOPY(dat, (char *)rtcmp, sizeof(RTCMP));

	if(vio_write(ptr->fd, (char *)&sndbuf, sizeof(VMSG) + sizeof(RTCMP), CONN_TIMEOUT) == -1)
#endif
	{
		ptr->flags |= CFLAG_ERROR;
		ptr->error = errno;
	}
}
