/* $Id: cmd_ulist.c,v 1.1 2001/04/09 18:30:44 mickey Exp $ */

#include <vserver.h>
#include <vproto/types.h>
#include <proto.h>
#include <extern.h>

/*
 * void cmd_ulist(CLDATA *ptr, u_char *dat);
 *
 * Show list of chatting users
 */

void cmd_ulist(CLDATA *ptr, u_char *dat)
{
	struct list	*lt	= (struct list *) dat;
	u_short		xcmd	= (u_short)ntohl(lt->cmd);
	signed long	xchan	= htonl(lt->chan);

	if(xcmd == CHAN && xchan < 0)
	{
		snd_svmsg(ptr, "* No informations on negative channels available");
	}
	else
	{
		register CLDATA	*cl;
		register int	i;
		TABLE		cltab;
		int		n	= 0;

		table_init(&cltab, ptr);

		for(i = 0; i < clients; i++)
		{
			cl = cl_addr(i);

			if((xcmd == ALL_CHAN)
			||(ptr->channel == cl->channel && xcmd == MY_CHAN)
			||(cl->channel == xchan && xcmd == CHAN))
			{
				if(!n)
				{
					if(clients>1)
						table_printf(&cltab, "\n* %s%d%s users online\n",
						S_FG_RED, clients, S_OFF);
					else
						table_printf(&cltab, "\n* %s%d%s user online\n",
						S_FG_RED, clients, S_OFF);
					table_printf(&cltab, "*\n");

					if(!(cfdata.flags & CF_SUPPRESS_IP))
						table_printf(&cltab, "*%s%s NICKNAME            CHANNEL IDLE      T FROM                                %s", S_FG_WHT, S_BG_BLU, S_OFF);
					else
						table_printf(&cltab, "*%s%s NICKNAME            CHANNEL IDLE      T %s", S_FG_WHT, S_BG_BLU, S_OFF);
				}

				if(cl->channel < 0)
				{
					if(!(cfdata.flags & CF_SUPPRESS_IP))
					{
						table_printf(&cltab, "\n* %-15s     ??????? %-9s %c %s",
							cl->nick, pftime(cl->stamp),
							(cl->type == CLIENT_FRONTEND) ? 'F' : 'G',
							cl->host);
					}
					else
					{
						table_printf(&cltab, "\n* %-15s     ??????? %-9s %c",
							cl->nick, pftime(cl->stamp),
							(cl->type == CLIENT_FRONTEND) ? 'F' : 'G');
					}
				}
				else
				{
					if(!(cfdata.flags & CF_SUPPRESS_IP))
					{
						table_printf(&cltab, "\n* %-15s %11d %-9s %c %s",
							cl->nick, cl->channel,
							pftime(cl->stamp),
							(cl->type == CLIENT_FRONTEND) ? 'F' : 'G',
							cl->host);
					}
					else
					{
						table_printf(&cltab, "\n* %-15s %11d %-9s %c",
							cl->nick, cl->channel,
							pftime(cl->stamp),
							(cl->type == CLIENT_FRONTEND) ? 'F' : 'G');
					}
				}
				n++;
			}
		}

		if(!n)
			snd_svmsg(ptr, "* No users on channel %s%d%s",
			S_FG_RED, xchan, S_OFF);
		else
			table_flush(&cltab);
	}
}
