/* $Id: extern.h,v 1.5 2002/06/23 23:16:07 mickey Exp $ */

#ifndef __VSERVER_EXTERN_H__
#define __VSERVER_EXTERN_H__

/**                              **
 * External variables in global.c *
 **                              **/

extern char		*prog_name;		/* Program name		*/
extern int		sock;			/* Server socket descr.	*/
extern struct sockaddr_in sock_in;		/* Socketaddr structure	*/
extern FILE		*lgf;			/* Log stream or NULL	*/
extern CFDATA		cfdata;			/* Configuration data	*/
extern VTOPIC		vtop;			/* Topic data structure	*/
extern TMSTAT		tmstat;			/* Timer status data	*/
extern VS_STAT		vs;			/* Server status data	*/
extern CLDATA		*cl_buf;		/* Client data buffer	*/
extern int		clients;		/* # of active clients	*/
extern ACLRULE		*acl_base;		/* ACL rule data buffer	*/
extern int		acl_numrules;		/* number of ACL rules	*/
extern AUTHREC		*auth_base;		/* Authority data	*/
extern int		auth_numrec;		/* # of authority recs.	*/
extern int		llog_fd;		/* Lastlog file desc.	*/
extern void		*llog_base;		/* Lastlog base address	*/
extern char		vserv_shutdown;		/* Server shutdown flag */
extern LLOGHEAD		*llog_header;		/* Lastlog header	*/
extern struct timeval	lastaccept;		/* Flood protect	*/
extern u_short		dynacl_next;		/* Next dynamic ACL rule*/

#ifdef MSGDB
extern char		*sql_cmd;		/* last SQL command	*/
#endif

#ifndef WIN32

extern int		ctlsock;		/* ctlsocket descriptor	*/
extern struct sockaddr_un saun;			/* ctlsocketaddr struct	*/

#else

extern SERVICE_STATUS	ssStatus;		/* Status of service	*/
extern SERVICE_STATUS_HANDLE sshStatusHandle;	/* Servicestatus handle	*/
extern DWORD		dwErr;			/* Error code		*/
extern TCHAR		szErr[256];		/* Error string		*/
extern u_char		wsa_is_init;		/* WinSock initialized?	*/

#endif

#endif /* __VSERVER_EXTERN_H__ */
