/* $Id: options.h,v 1.2 2002/06/23 23:16:08 mickey Exp $ */

#ifndef _OPTIONS_H_
#define _OPTIONS_H_

#include <vproto/param.h>

/*
 * The default TCP port number that vserver will listen on
 * for incoming connection requests of remote clients. This
 * value may be overridden by the vserver -p <port> option.
 */

#define	SERVER_PORT		1168

/*
 * The minimum size in characters that the vserver will
 * accept for a users password. Passwords shorter than
 * this value will be rejected by the server.
 */

#define	MINPASSWDSIZE		4

/*
 * The size in bytes of some buffers used around somewhere to
 * receive server messages etc.
 */

#define	SVMSGBUF		8192

/*
 * The default number of logfile generations that vserver will
 * keep when rotating logfiles via SIGUSR1. This value may
 * be overridden by the vserver -k <num> commandline option.
 */

#define	DEF_NUMLOGFILES		8

/*
 * The maximum number of arguments that vserver will support with
 * client commands that accept a list of arguments as input.
 */

#define	VCMD_MAXARGS		24

/*
 * The default client option mask.
 */

#define DEF_CLOPTMASK		(CL_OPT_WAKEUP | CL_OPT_SGNMSG)

/*
 * The maximum allowed number of lastlog entries that are displayed
 * per lastlog command.
 */

#define	LASTLOG_MAX_LIST	300

/*
 * The default TTL value for dynamic ACL rules.
 */

#define	DYNACL_DEFAULT_TTL		0x15180		/* 1 day */

/*
 * The maximum allowable TTL for dynamic ACL rules.
 */

#define DYNACL_MAX_TTL			0x76A700	/* 90 days */

/*
 * The first rule number at which dynamic ACLs are being created.
 */

#define	DYNACL_FIRST_RULE		0xD00F

/*
 * The default maximum number of pending connection requests
 * that vserver and vping will support. This value may be
 * overridden by the -o <num> commandline option of vping/vserver.
 */

#define	DEF_MAX_PENDING		4

/*
 * The connection timeout in seconds that the server will utilize
 * for client connections. If a read or write operation on the
 * client's socket cannot be performed within the specified time
 * the operation is forcely aborted and the corresponding client
 * will be disconnected. The default value is 10 seconds.
 */

#define	CONN_TIMEOUT		8

#endif /* _OPTIONS_H_ */
