/* $Id: table.c,v 1.2 2002/06/23 23:16:07 mickey Exp $ */

#include <vserver.h>
#include <vserver.h>
#include <proto.h>
#include <extern.h>

#include <errno.h>
#include <stdarg.h>

/*** Code ***/

void table_init(TABLE *table, CLDATA *cl)
{
	table->client = cl;
	table->svcmd.cmd = htonl(SERV_MSG);
	table->buf[0] = '\0';	
}

void table_printf(TABLE *table, char *fmt, ...)
{
	va_list ap;
	off_t	offset	= strlen(table->buf);
	char	*s	= &table->buf[offset];

	va_start(ap, fmt);

	vsprintf(s, fmt, ap);

	if(strlen(table->buf) > TABLE_TRESHOLD)
	{
		table_flush(table);
		table_init(table, table->client);
	}

	va_end(ap);
}

void table_xprintf(TABLE *table, char *fmt, ...)
{
	va_list ap;
	off_t	offset	= strlen(table->buf);
	char	*s	= &table->buf[offset];

	va_start(ap, fmt);

	if(!offset && *fmt == '\n')
		++fmt;

	vsprintf(s, fmt, ap);

	if(strlen(table->buf) > TABLE_TRESHOLD)
	{
		table_flush(table);
		table_init(table, table->client);
	}

	va_end(ap);
}

void table_flush(TABLE *table)
{
	size_t len = strlen(table->buf);

	if(table->client->flags & CFLAG_ERROR)
		return;

	table->svcmd.len = htonl(len);

	len += sizeof(table->svcmd);

	if(vio_write(table->client->fd, &table->svcmd, len, CONN_TIMEOUT) != len)
	{
		vlog(VLOG_ERR, "ERROR: vio_write() failed during tblflush()");

		table->client->flags |= CFLAG_ERROR;
		table->client->error = errno;
	}
}
